package com.usky.fire.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.common.core.exception.BusinessException;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.fire.domain.BscEnterpriseStreetTown;
import com.usky.fire.mapper.BscEnterpriseStreetTownMapper;
import com.usky.fire.service.BscEnterpriseStreetTownService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 企业自主管理大屏统计（街镇） 服务实现类
 * </p>
 *
 * @author JCB
 * @since 2022-10-09
 */
@Service
public class BscEnterpriseStreetTownServiceImpl extends AbstractCrudService<BscEnterpriseStreetTownMapper, BscEnterpriseStreetTown> implements BscEnterpriseStreetTownService {

    @Override
    public Object enterpriseStreetTown(String moduleType, String dataType, String streetTown) {
        LambdaQueryWrapper<BscEnterpriseStreetTown> queryWrapper = Wrappers.lambdaQuery();
        switch (moduleType) {
            case "enterpriseAutonomy":
                queryWrapper.select(BscEnterpriseStreetTown::getEnterpriseAutonomy);
                break;
            case "iotDevice":
                queryWrapper.select(BscEnterpriseStreetTown::getIotDevice);
                break;
            case "patrolInspection":
                queryWrapper.select(BscEnterpriseStreetTown::getPatrolInspection);
                break;
            case "streetCompany":
                queryWrapper.select(BscEnterpriseStreetTown::getStreetCompany);
                break;
            default:
                throw new BusinessException("参数错误");
        }
        queryWrapper.eq(BscEnterpriseStreetTown::getStreetTown, streetTown)
                .orderByDesc(BscEnterpriseStreetTown::getId)
                .last(" limit 1");
        List<BscEnterpriseStreetTown> list = this.list(queryWrapper);
        Object data = null;
        if (CollectionUtils.isNotEmpty(list)) {
            switch (moduleType) {
                case "enterpriseAutonomy":
                    data = list.get(0).getEnterpriseAutonomy();
                    break;
                case "iotDevice":
                    data = list.get(0).getIotDevice();
                    break;
                case "patrolInspection":
                    data = list.get(0).getPatrolInspection();
                    break;
                case "streetCompany":
                    data = list.get(0).getStreetCompany();
                    break;
            }
        }
        JSONObject jsonObject = JSONObject.parseObject(data.toString());
        Object disparateData = jsonObject.get(dataType);
        return disparateData;
    }
}
